import socket
import os
from datetime import datetime
from dataclasses import dataclass, field
from traceback import format_exc

tracing=False
def trace(*msg):
	if not tracing: return
	print(f'[{datetime.now()}]',*msg)

statii={}
statii[200]='OK'
statii[403]='Forbidden'
statii[404]='Not found'
statii[418]="I'm a teapot"

@dataclass
class Request():
	version:str='HTTP/1.0'
	method:str='GET'
	host:str=''
	path:list=field(default_factory=list) # This has a str variant
	params:list=field(default_factory=list)
	headers:dict=field(default_factory=dict)
	body:str=''
	
	@property
	def path_str(self):
		return '/'.join(self.path)

@dataclass
class Response():
	version:str='HTTP/1.0'
	status:int=200
	headers:dict=field(default_factory=dict)
	body:str=''
	_st:str=''
	
	@property
	def statustext(self):
		return self._st or statii[self.status]

def parsereq(request):
	parsed=Request()
	if '\r\n\r\n' in request: blob,parsed.body=request.split('\r\n\r\n',1)
	else: blob=request
	blob=blob.split('\r\n')
	trace(blob)
	#parsed['headers']={m.split(': ',1)[0].lower():m.split(': ',1)[1] for m in blob[1:]} # I do not care about duplicate headers. Do not fucking asking me about duplicate headers. Duplicate headers is niggers.
	# Fuck I need to support duplicate headers
	for m in blob[1:]:
		k,v=m.split(': ',1)
		k=k.lower()
		try: parsed.headers[k].append(v)
		except KeyError: parsed.headers[k]=v
		except AttributeError: parsed.headers[k]=[parsed.headers[k],v]
	parsed.method,path,parsed.version=blob[0].split(' ')
	path=path.split('?',1)
	parsed.path=path[0].split('/')
	if len(path)>1:
		parsed.params=[n.split('=',1) for n in path[1].split('&')] # Need to support duplicate params though, argh.
	return parsed

def unparse(resp):
	out=[]
	for k,v in resp.headers.items():
		if isinstance(v,list):
			for n in v: out.append(f'{k}: {n}')
		else: out.append(f'{k}: {v}')
	heads='\r\n'.join(out)
	return f'{resp.version} {resp.status} {resp.statustext}\r\n{heads}\r\n\r\n{resp.body}'

def get_req(conn):
	req=b''
	while not req:
		try:
			out=conn.recv(100)
			while out:
				req+=out
				out=conn.recv(100)
		except BlockingIOError: trace('failed')
	return req

def run(bind,callback):
	websock=socket.socket(socket.AF_UNIX)
	try: os.remove(bind)
	except FileNotFoundError: pass
	websock.bind(bind)
	os.chmod(bind,511)
	websock.listen()
	while True:
		conn,fag=websock.accept()
		conn.settimeout(0)
		req=get_req(conn)
		trace(req)
		if not req: conn.send(b'nigger'); conn.close(); exit() # wtf
		try: parsed=parsereq(req.decode('utf-8'))
		except: format_exc()
		trace(parsed)
		resp=callback(parsed)
		if resp:
			headers={'Content-Length':len(resp.body),'Server':'sps/1.0'} # Can add more defaults whenever
			resp.headers=headers|resp.headers
			conn.send(unparse(resp).encode('utf-8'))
		conn.close()